class Fern {
  final String axiom = "FT";
  final String[][] rules = { {"F", "FF"},
                             {"X", "DF[+X][-X]FF[+X][-X]FX"},
                             {"L", ""},
                             {"R", ""},
                             {"T", "F[+X][-X]FF[+X][-X]FT"},
                             {"+", "+"},
                             {"-", "-"},
                             {"[", "["},
                             {"]", "]"},
                             {"D", ""} };
                           
                             
  String computedWord;
  int iterations;
  float size, angle, scaleFactor;
  float petalsize;
  
  Fern(float size, float angle, float scaleFactor, float petalsize) {
    computedWord = axiom;
    iterations = 0;
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
    this.petalsize = petalsize;
  }
  
  void iteration() {
    char s;
    String newWord = "";
    size *= scaleFactor;
    //petalsize *= scaleFactor;
    for(int i = 0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      for(int j=0; j<rules.length; j++) {
        if (s == rules[j][0].charAt(0)) {
          newWord += rules[j][1];
          break;
        }
      }
    }
    iterations++;
    computedWord = newWord;
    println(iterations +": " + computedWord);
  }
  
  void arc(float size, int deg) {
  for(int i = 0; i<deg; i++) {
    t.forward(size);
    t.right(1);
  }
}
  
  void petal(float size) {
    strokeWeight(10);
    t.left(30);
    arc(size, 60);
    t.right(120);
    arc(size, 60);
    t.right(120);
    strokeWeight(2);
  }
  
  void drawFern(Turtle t) {
    char s;
    for(int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if (s == 'F') {
        t.right(random(-4,4));
        t.forward(size);
        t.forward(random(1,5));
      } else if (s == '+') {
        t.right(angle);
      } else if (s == '-') {
        t.left(angle);
      } else if (s == '[') {
        t.push();
      } else if (s == ']') {
        t.pop();
      } else if (s == 'T') {
        petal(petalsize);
        size += 3*scaleFactor;
        //fill(255,0,0);
        ////t.left(30);
        //petal(petalsize);
        t.setHeading(0);
      } else if (s == 'X') {
        fill(#DE0B9F);
        //t.left(30);
        petal(petalsize);
      } else if (s == 'D') {
        
      }
    }
  }
}
        
      
