class Plant {
  final String axiom = "FFX";
                             
final String[][] rules = { {"F", "F", "F", "F", "F", "F", "F","F"},
                           {"X", "[+FFX][--FFXTL]", "F-X+", "F-X", "FFX", "FFX", "FX"},
                           {"L", "[-fL][+fL]", "L", "L", "L", "[-fL][+fL]", "[-fL][+fL]"},
                           {"T", "T", "T", "T", "T", "T", "T"},
                           {"f", "f", "f", "f", "f", "f", "f"},
                           {"+", "+", "+", "+", "+", "+", "+"},
                           {"-", "-", "-", "-", "-", "-", "-"},
                           {"[", "[", "[", "[", "[", "[", "["},
                           {"]", "]", "]", "]", "]", "]", "]"} };
                             
  String computedWord;
  int iterations;
  float size, angle, scaleFactor;
  
  Plant(float size, float angle, float scaleFactor) {
    computedWord = axiom;
    iterations = 0;
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
  }
  
  float strokeWeight;
  
  void iteration() {
    strokeWeight = 10;
    t.setHeading(0);
    //t.forward(100);
    char s;
    String newWord = "";
    size1 *= 0.9;
    size2 *= 0.9;
    size *= scaleFactor;
    for(int i = 0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      for(int j=0; j<rules.length; j++) {
        if (s == rules[j][0].charAt(0)) {
          newWord += rules[j][(int)random(1,7)];
          break;
        }
      }
    }
    iterations++;
    computedWord = newWord;
    println(iterations +": " + computedWord);
  }
  
  float size1 = 30;
  float size2 = 10;
  
  void drawPlant(Turtle t) {
    char s;
    for(int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if (s == 'F') {
        stroke(#7BB205);
        strokeWeight(20);
        if(i>1) {t.right(random(-2,2));}
        t.forward(size);
      } else if (s == '+') {
        t.right(angle);
      } else if (s == '-') {
        t.left(angle);
      } else if (s == '[') {
        t.push();
      } else if (s == ']') {
        t.pop();
      } else if (s == 'T') {
        stroke(#FA88EF);
        t.setHeading(180);
        strokeWeight(4);
        //t.forward(10);
      } else if (s == 'L') {
        strokeWeight(0);
        fill(#FA88E0);
        ellipse(t.getX(), t.getY(), size1, size1);
        fill(#BFFA88);
        ellipse(t.getX(), t.getY(), size2, size2);
      } else if (s == 'f') {
        strokeWeight(4);
        stroke(#FA88EF);
        t.forward(size/3);
      }
    }
  }
}
        
      
